/*

  Natalia Aparici Pérez, Xosé Lois Piñeira y David Riol Garcia
  NIA: XXXXXX            NIA: XXXXXX         NIA: 106214

  Ingeniería en Diseño Industrial
  3º de GEDI 2021 - 2022
  UATEA G202
  Profesor: Joan Gómez Clapers

  Proyecto Taller: Midcourse project (Halloween)

  ----------------------------------------------------------------
*/

//Include all the libraries, for the servo and the led strip
//Add the file with the notes defined for the buzzer songs, makes the composition easier
#include <Servo.h>
#include <Adafruit_NeoPixel.h>
#include "pitches.h"

//Define the pins

#define IR 5 //IR obstacle sensor

//Number of leds in each strip
#define LED_COUNT 16  //1st
#define LED_COUNT1 3  //2nd 
#define LED_COUNT2 3  //3rd 

//led strips
#define LED_PIN 2 //1st
#define LED_PIN1 3 //2nd
#define LED_PIN2 4 //3rd

//connections for both servos
#define SERVO1 6 
#define SERVO2 7

//define objects for each servo
Servo myservo1;
Servo myservo2;

//define global variables
int decideMotor; //for the random decisions of the servo openings

int inicio[] = { NOTE_E5, NOTE_F5, NOTE_E5, NOTE_F5, NOTE_E5, NOTE_F5,}; //initial melody
int caramelo[] = { NOTE_G6, NOTE_G6, NOTE_G6, NOTE_G6, NOTE_G6, NOTE_G6, NOTE_G6, NOTE_G6 }; //melody when choosing candy
int premio[] = { NOTE_G5, NOTE_C5, NOTE_E5, NOTE_G5, NOTE_D6, NOTE_E6, NOTE_G6, NOTE_E6 }; //jackpot sound

//define each song duration. 4 for quarters, 8 for eights... composition of the song
int noteDuration1[] = { 4, 4, 4, 4, 4, 4};
int noteDuration2[] = { 8, 8, 8, 8, 8, 8, 8, 8 };
int noteDuration3[] = { 8, 8, 8, 8, 8, 8, 4, 4 };

//call the object funcitions for each led strip, with its specs
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel strip1(LED_COUNT1, LED_PIN1, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel strip2(LED_COUNT2, LED_PIN2, NEO_GRB + NEO_KHZ800);


//////////////// SETUP ////////////////

void setup()
{
  Serial.begin(9600);

  //define servo pins
  myservo1.attach(SERVO1);
  myservo2.attach(SERVO2);

  //initiate the strip sequences
  strip.begin();
  strip1.begin();
  strip2.begin();

  //all leds start off
  strip.show();
  strip1.show();
  strip2.show();

  //full brightness for better effect on the dark
  strip.setBrightness(100);
  strip1.setBrightness(100);
  strip2.setBrightness(100);

  //IR as a input for the pin 5
  pinMode(IR, INPUT);

  //the servos must start in 0deg, meaning they are always closed
  myservo1.write(0);
  myservo2.write(0);

}

//////////////// LOOP ////////////////

void loop() {

  if (rainbow(10)) //this function checks if a hand is under, but also how leds in gradient
  {
    
    setColor(strip.Color(0, 255, 0));  //if we put our hand under, turn on these leds, in green.
 
    theaterChase(strip1.Color(0, 255, 0), 20);  //also do this animation for the ones on top
    theaterChase(strip2.Color(0, 255, 0), 20);
    
    sonidoCaramelo(); //and play the sound of b eginnig the decision process

    
    decideMotor = random(0, 20); //first decision: jackpot option (1 in 20 possibilities) 

    
    if (decideMotor == 0) //jackpot case
    {
      carameloBote(); //this function opens the servo of the good candy for 2
      
      
      theaterChase(strip1.Color(255, 255, 0), 10); //turn on stroboscopic lights in yellow
      theaterChase(strip2.Color(255, 255, 0), 10);
      
      sonidoPremio(); // play the jackpot sound effect
      delay(200);  //do all this for a while before returning to the original state.
    }

    else  //NO jackpot case
    {
      decideMotor = random(1, 3); //make a decision for one of the two servos

      if (decideMotor == 1) {
        carameloBueno(); //open the servo for 1-2 good candy 
        setColor(strip1.Color(0, 255, 0)); //also make the deposit led turn flat green

      }

      else {
        carameloMalo(); //deposit 2 bad candy in the hand of the user
        setColor(strip2.Color(0, 255, 0)); //show the deposit led in green
      }
    }

    while (readIR()) { //this happens when we stop putting our hand after getting the candy

      delay(1000); //wait for a second with the "decision" state
      setColor(strip.Color(0, 255, 0)); //put all the leds in green
      setColor(strip1.Color(0, 255, 0));
      setColor(strip2.Color(0, 255, 0));
    }
  }
  sonidoInicio(); //play the intial sound effect before looping again the intial state
}

//////////////// PIXEL STRIP ////////////////

void setColor(uint32_t color) //we need to declare this variable to make the strip understand the colors
{
  for (int i = 0; i < strip.numPixels(); i++) { // For each pixel in strip set the pixel color in RAM
    strip.setPixelColor(i, color);
    strip1.setPixelColor(i, color);
    strip2.setPixelColor(i, color);
  }
  strip.show(); //execute the loop for every strip
  strip1.show();
  strip2.show();
}

boolean rainbow(int wait) {     //returns true if IR detects anything
  // Hue of first pixel runs 5 complete loops through the color wheel.
  // Color wheel has a range of 65536 but it's OK if we roll over, so
  // just count from 0 to 5*65536. Adding 256 to firstPixelHue each time
  // means we'll make 5*65536/256 = 1280 passes through this outer loop:
  for (long firstPixelHue = 0; firstPixelHue < 5 * 65536; firstPixelHue += 256) {
    for (int i = 0; i < strip.numPixels(); i++) { // For each pixel in strip...
      // Offset pixel hue by an amount to make one full revolution of the
      // color wheel (range of 65536) along the length of the strip
      // (strip.numPixels() steps):
      int pixelHue = firstPixelHue + (i * 65536L / strip.numPixels());
      // strip.ColorHSV() can take 1 or 3 arguments: a hue (0 to 65535) or
      // optionally add saturation and value (brightness) (each 0 to 255).
      // Here we're using just the single-argument hue variant. The result
      // is passed through strip.gamma32() to provide 'truer' colors
      // before assigning to each pixel:
      strip.setPixelColor(i, strip.gamma32(strip.ColorHSV(pixelHue)));
    }
    strip.show(); // Update strip with new contents
    if (readIR())
    {
      Serial.println("Detected"); //Update if the IR detects any hand under
      return true; //return true for the IR function on the loop, starting the decision process
    }
    delay(wait);  // Pause for a moment
  }
  Serial.println("NOT DETECTED"); //if no hand detected, return false, and the loop will execute this funtion again
  return false;
}

void theaterChase(uint32_t color, int wait) { //this function makes a stroboscopic efect on leds, depending on the delay 
  for (int a = 0; a < 10; a++) { // Repeat 10 times
    for (int b = 0; b < 3; b++) { //  'b' counts from 0 to 2
      strip.clear();         //   Set all pixels in RAM to 0 (off)
      // 'c' counts up from 'b' to end of strip in steps of 3
      for (int c = b; c < strip.numPixels(); c += 3) {
        strip.setPixelColor(c, color); // Set pixel 'c' to value 'color'
      }
      strip.show(); // Update strip with new contents
      delay(wait);  // Pause for a moment
    }
  }
}

//////////////// IR ////////////////

boolean readIR() //this function serves as a detector of the hand under, and the reainbow function gets the response for the loop
{
  if (digitalRead(IR) == LOW)//read the IR digital signal
    return true;//returns true if we put our hand under

  return false;//or nothing if no hand detected, just the oppsite from the rainbow function
}

//////////////// SERVO MOVEMENT ////////////////


void carameloBueno() {// open for a quick moment the good candy container
  myservo1.write(60); //go to 60 deg 
  delay(150); //the servo has 150 ms to do it, so if we put more degrees, it wont get there
  myservo1.write(0);// go back to the closed position
}

void carameloMalo() {// same as previous function, but with the 'bad' container
  myservo2.write(60);
  delay(150);
  myservo2.write(0);
}

void carameloBote() {
  setColor(strip.Color(255, 255, 0)); //set the color of the under strip to yellow before any effect

  myservo1.write(90); //fully open the good container
  delay(2000);// wit for 2s
  myservo1.write(0);//close the now empty container
}

//////////////// BUZZER ////////////////

void sonidoInicio() { //this function plays the intial sound effect
  for (int thisNote = 0; thisNote < 6; thisNote++) {//for every note..
    int noteDuration = 1000 / noteDuration1[thisNote];// aply each note duration in the array
    tone(8, inicio[thisNote], noteDuration);// play each note, wuth its now assigned duration
    int pauseBetweenNotes = noteDuration * 1.30; //delay a little the time between notes
    delay(pauseBetweenNotes);
    noTone(8);//stop the music after 8 notes
  }
}
void sonidoCaramelo() {//this function plays the decision sound effect, same as previous but with other notes, and times
  for (int thisNote = 0; thisNote < 8; thisNote++) {
    int noteDuration = 1000 / noteDuration2[thisNote];
    tone(8, caramelo[thisNote], noteDuration);
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    noTone(8);
  }
}
void sonidoPremio() {//this function plays the jackpot sound effect, same as previous but with other notes, and times
  for (int thisNote = 0; thisNote < 8; thisNote++) {
    int noteDuration = 1000 / noteDuration3[thisNote];
    tone(8, premio[thisNote], noteDuration);
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    noTone(8);
  }
}
